<?php
include "common.php";

echo "Running MakeDatabase.php...\n";

function cmp ($a, $b) {
  global $FilenamePattern;
  $a = preg_replace($FilenamePattern, "\\2-\\3", $a);
  $b = preg_replace($FilenamePattern, "\\2-\\3", $b);
  return -strcmp ($a, $b);
}

$ndb = array();
$deletethumbs = array_flip(scandir("thumbs"));
unset($deletethumbs["."]); unset($deletethumbs[".."]);
$now = time();

foreach (scandir("shots") as $shot) {
  unset($deletethumbs[$shot]);
  if (preg_match($FilenamePattern, $shot)) {
    if (
      is_array($db) &&
      array_key_exists($shot, $db) &&
      array_key_exists("db_updated", $db[$shot]) &&
      $db[$shot]["db_updated"] >= filemtime("shots/$shot")
    ) {
      $ndb[$shot] = $db[$shot];
    } else {
      echo "Adding shots/$shot...\n";
      if (!file_exists("$shot.comment")) {
        $comment = "";
      } else {
        $handle = fopen("$shot.comment", "r");
        $comment = rtrim(fgets($handle));
        pclose($handle);
      }
      $ndb[$shot] = array(
        "db_updated" => $now,
        "comment" => $comment
      );
    }
    if (
      !file_exists("thumbs/$shot") ||
      filemtime("shots/$shot") > filemtime("thumbs/$shot")
    ) {
      echo "Creating thumbs/$shot...\n";
      system("convert -geometry 640x640 -normalize -quality 70 shots/$shot thumbs/$shot");
    }
  }
}

uksort($ndb, "cmp");
$handle = fopen("ShotDatabase.php", "w");
fwrite($handle, "<?php\n \$db = ".var_export($ndb, TRUE)."\n?>\n");
fclose($handle);

$deletethumbs = array_keys($deletethumbs);
for ($k=0; $k<count($deletethumbs); $k++) {
  echo "Deleting spurious thumbs/$deletethumbs[$k]...\n";
  unlink("thumbs/$deletethumbs[$k]");
}

echo "Done running MakeDatabase.php...\n";
?>
