<?php
include "common.php";

function cmp ($a, $b) {
  global $FilenamePattern;
  $a = preg_replace($FilenamePattern, "\\2-\\3", $a);
  $b = preg_replace($FilenamePattern, "\\2-\\3", $b);
  return -strcmp ($a, $b);
}

#DateTimeOriginal

foreach (scandir("queue") as $pdf) {
  if (preg_match("/.(pdf|PDF)$/", $pdf)) {
    echo "Running pdfimages on $pdf ...\n";
    system("pdfimages -j \"queue/$pdf\" \"queue/$pdf\"");
    system("rm \"queue/$pdf\"");
  }
}

$news=array();
$ctimecount=0;
foreach (scandir("queue") as $newshot) {
  $reg = "([0-9]{2}):([0-9]{2}):20([0-9]{2})-([0-9]{2}):([0-9]{2}):([0-9]{2})";
  if ($newshot == "." or $newshot == "..") {
  } elseif (preg_match("/^P-$reg.(jpg|pnm)$/", $newshot, $r)) {
# luvcview naming: P-mm:dd:yyyy-hh:mm:ss.jpg
    $mo=$r[1]; $dd=$r[2]; $yy=$r[3]; $hh=$r[4]; $mi=$r[5]; $ss=$r[6];
    $news[$newshot] = "$yy$mo$dd-$hh$mi$ss";
  } elseif (preg_match("/^P-([0-9]{2})([0-9]{2})([0-9]{2})-([0-9]{2})([0-9]{2})([0-9]{2}).(jpg|png)$/", $newshot, $r)) {
# Alternative dated naming: P-yymmdd-hhmmss.ext
    $yy=$r[1]; $mo=$r[2]; $dd=$r[3]; $hh=$r[4]; $mi=$r[5]; $ss=$r[6];
    $news[$newshot] = "$yy$mo$dd-$hh$mi$ss";
  } elseif (preg_match("/^20([0-9]{2})([0-9]{2})([0-9]{2})_([0-9]{2})([0-9]{2})([0-9]{2}).(jpg|png)$/", $newshot, $r)) {
# Alternative dated naming: 20yymmdd_hhmmss.ext
    $yy=$r[1]; $mo=$r[2]; $dd=$r[3]; $hh=$r[4]; $mi=$r[5]; $ss=$r[6];
    $news[$newshot] = "$yy$mo$dd-$hh$mi$ss";
  } elseif (preg_match("/^Skype-20([0-9]{2})([0-9]{2})([0-9]{2})-([0-9]{2})([0-9]{2})([0-9]{2}).(jpeg|jpg|png)$/", $newshot, $r)) {
# Alternative dated naming: Skype-20yymmdd-hhmmss.jpeg
    $yy=$r[1]; $mo=$r[2]; $dd=$r[3]; $hh=$r[4]; $mi=$r[5]; $ss=$r[6];
    $news[$newshot] = "$yy$mo$dd-$hh$mi$ss";
  } elseif (preg_match("/.(jpg|JPG)$/", $newshot)) {
    $exif = exif_read_data("queue/$newshot");
    $dt = "";
    if (array_key_exists("DateTime", $exif)) $dt = $exif["DateTime"];
    if (array_key_exists("DateTimeOriginal", $exif)) $dt = $exif["DateTimeOriginal"];
    if ($dt == "") {
      echo "Couldn't find EXIF date-time for $newshot, using ctime...\n";
      $dt = date("Y:m:d H:i:s", filectime("queue/$newshot")+($ctimecount++));
    }
    $news[$newshot] = preg_replace(
      "/20([0-9]{2}):([0-9]{2}):([0-9]{2}) ([0-9]{2}):([0-9]{2}):([0-9]{2})/",
      "\\1\\2\\3-\\4\\5\\6",
      $dt
    );
  } elseif (preg_match("/.(png|PNG)$/", $newshot)) {
    echo "PNG image, using ctime...\n";
    $dt = date("Y:m:d H:i:s", filectime("queue/$newshot")+($ctimecount++));
    $news[$newshot] = preg_replace(
      "/20([0-9]{2}):([0-9]{2}):([0-9]{2}) ([0-9]{2}):([0-9]{2}):([0-9]{2})/",
      "\\1\\2\\3-\\4\\5\\6",
      $dt
    );
  } else echo "I'm mystified by $newshot\n";
}
asort($news);

print_r($news);

foreach ($news as $s => $dt) {
  if (!isset($default_prefix)) {
    $default_prefix = preg_replace($FilenamePattern, "\\1", key($db));
  }
  print "Enter prefix for $s [$default_prefix]: ";
  $p = rtrim(fgets(STDIN));
  if ($p == "") {
    $p=$default_prefix;
  } else {
    $default_prefix = $p;
  }
  $keys = array_keys($db);
  for(
    $j=0;
    $j<count($keys) and preg_replace($FilenamePattern, "\\1", $keys[$j])!=$p;
    ++$j
  );
  if ($j == count($keys)) {
    $default_comment = "";
    print "Enter comment for $p-$dt.jpg: ";
  } else {
    $default_comment = $db[$keys[$j]]["comment"];
    if (preg_match("/^(.*\()([0-9]+)(\)\.*)$/", $default_comment, $r)) {
      $default_comment = $r[1].($r[2]+1).$r[3];
    } else {
      $default_comment = preg_replace(
        "/^(.*[^\.])(\.*)$/", "\\1 (2)\\2", $default_comment
      );
    }
    print "Default := \"$default_comment\"\n";
    print "Enter comment for $p-$dt.jpg [Default]: ";
  }
  $c = rtrim(fgets(STDIN));
  if ($c == "") $c=$default_comment;
  $handle = fopen("$p-$dt.jpg.comment", "w");
  fwrite($handle, $c);
  fclose($handle);
  system("convert -geometry 1600x1600\> -quality 70 \"queue/$s\" shots/$p-$dt.jpg");
  system("rm \"queue/$s\"");
  $db["$p-$dt.jpg"] = array("comment" => $c);
  uksort($db, "cmp");
}

system("make");

?>
